/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the QtGui module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Licensees holding valid Qt Enterprise licenses may use this file in
** accordance with the Qt Enterprise License Agreement provided with the 
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  
**
** If you have questions regarding the use of this file, please use
** contact form at http://qt.digia.com
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QPLATFORMEVENTLOOPINTEGRATION_QPA_H
#define QPLATFORMEVENTLOOPINTEGRATION_QPA_H

#include <QtCore/qglobal.h>
#include <QtCore/QScopedPointer>

QT_BEGIN_HEADER

QT_BEGIN_NAMESPACE

QT_MODULE(Gui)

class QPlatformEventLoopIntegrationPrivate;

class Q_GUI_EXPORT QPlatformEventLoopIntegration
{
    Q_DECLARE_PRIVATE(QPlatformEventLoopIntegration);
public:
    QPlatformEventLoopIntegration();
    virtual ~QPlatformEventLoopIntegration();

    virtual void startEventLoop() = 0;
    virtual void quitEventLoop() = 0;
    virtual void qtNeedsToProcessEvents() = 0;

    qint64 nextTimerEvent() const;
    void setNextTimerEvent(qint64 nextTimerEvent);

    static void processEvents();
protected:
    QScopedPointer<QPlatformEventLoopIntegrationPrivate> d_ptr;
private:
    Q_DISABLE_COPY(QPlatformEventLoopIntegration);
    friend class QEventDispatcherQPA;
};

QT_END_NAMESPACE

QT_END_HEADER

#endif // QPLATFORMEVENTLOOPINTEGRATION_QPA_H
